world
	mob = /mob/PC/

var/HAZE_LAYER = MOB_LAYER-1

proc/distance(atom/A, atom/B) // This procedure gets the distance from one object to another.
  return sqrt((A.x - B.x)**2 + (A.y - B.y)**2) // Standard distance formula you might find in a math textbook.

mob/PC
	Stat()
		statpanel("Vitals")
		stat("Experience [exp]/101")
		stat("Location: [src.x],[src.y],[src.z]")


mob
	var
		exp = 100
	proc
		death(mob/M) // Defines the death Procedure.
			new/obj/Corpse(src.loc,src) // Creates a new Corpse
			src.gravelocate()
			src << "You've died, [M] killed you."
			src.invisibility = 1 // These lines change the player to simulate death
			src.icon_state = "Ghost"
			src.sight = SEE_SELF
			src.dead = 1
			for(var/area/death_haze/A in world) // To add the haze
				if(A.coverhaze)
					src << A.coverhaze

		gravelocate() // We'll use this to find the closest grave
			var/closestnum = 999999999
			var/obj/Grave_Stone/Z
			for(var/obj/Grave_Stone/G in world)
				if(G.z == src.z)
					var/dist = distance(src,G) // Calls the distance formuka
					if(dist < closestnum) // Compares the distance to the distance to the previously determined closest distance and completes necessary actions if it is less.
						closestnum = dist
						Z = G
			src.loc = Z.loc // Locates at the closest grave


//////////////////////The Principles for the Haze were drawn from shadowdarke's RoofLib
area
	var// Necessary variable
		icon/hazeicon
		haze_state = ""
		image/coverhaze
	Del()
		if(coverhaze)
			del(coverhaze)
			..()
	New()
		..()
		if(hazeicon)
			coverhaze = image(hazeicon,src,haze_state,HAZE_LAYER) // Defines the coverhaze

	death_haze
		icon = 'icons.dmi'
		hazeicon = 'DeathHaze.dmi'





var
	grave_num = 0

obj
	Grave_Stone
		icon = 'icons.dmi'
		icon_state = "gstone"
		density =  1
		var
			idtag
		New()
			..()
			spawn(rand(1,10))
				grave_num += 1
				src.name = "Grave [grave_num]"
		verb
			Ressurect() // Resurrection
				set src in oview(1)
				if(usr.dead)
					switch(input("Would You like to ressurect here? You will lose half your experience if you do so. You may also find your corpse and ressurect for no penalty.") in list ("Yes","No, I Will find my corpse."))
						if("Yes")
							usr.exp = round(usr.exp/2) // Necessary ressurection penalties
							usr.icon_state = "Mob"
							usr.invisibility = 0
							usr.dead = 0
							for(var/obj/Corpse/C in world) // Deletes corpse
								if(C.name == "[usr]'s Corpse")
									del(C)
							for(var/area/death_haze/A in world) // Removes the player's haze.
								if(A.coverhaze)
									usr.client.images -= A.coverhaze
				else
					usr << "You are not dead."


obj/Corpse // The corpse
	var
		ownedby = ""

	New(Loc,mob/owner,position)// We want the corpse to be able to be identified and to do some other cool stuff on creation
		src.name = addtext(owner.name,"'s Corpse")
		src.ownedby = "[owner.name]"
		src.icon = 'icons.dmi'
		src.icon_state = "Mob1Death"
		src.dir = owner.dir
	verb/Ressurect() // Ressurect yourself!
		set src in oview(1)
		if(istype(usr,/mob/PC/)) // Makes sure it is a player
			if(src.ownedby == "[usr]")
				usr.icon_state = "Mob" //  Stuff here resets the player
				usr.invisibility = 0
				usr.dead = 0
				for(var/area/death_haze/A in world) // Removes the death haze
					if(A.coverhaze)
						usr.client.images -= A.coverhaze
				del(src)



